/* wybieramy typ kalkulatora */
//#define USE_TI89
//#define USE_TI92PLUS
#define USE_V200

/* optymalizacja dostpu do procedur ROMu */
#define OPTIMIZE_ROM_CALLS

/* bdziemy zwraca warto */
#define RETURN_VALUE

/* rozszerzenia AMS 1.01 */
#define MIN_AMS 101

#include <tigcclib.h>

long long int
smiher(short int n, short int x)
{
	long long int st = 1;	/* pierwszy element */
	long long int nd;	/* drugi element */
	long long int cur;	/* element aktualny */
	short int count = 3;	/* licznik */

	nd = 2 * x;

	while (count <= n + 1) {

		cur = 2 * x * nd - 2 * (count - 2) * st;
		st = nd;
		nd = cur;
		++count;

	}

	return nd;
}

void
_main(void)
{
	ESI argptr = top_estack;	/* wskanik do argumentw */
	short int n = GetIntArg(argptr);
	short int x = GetIntArg(argptr);
	long long int i = GetIntArg(argptr);
	long long int ret = 0;

	for (; i > 0; --i) {
		ret = smiher(n, x);
	}

	/* usuwamy argumenty ze stosu */
	while (GetArgType(top_estack) != END_TAG)
		top_estack = next_expression_index(top_estack);
	top_estack--;

	push_longint(ret);
}
